package net.sourceforge.nattable.columnRename;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.command.AbstractColumnCommand;
import net.sourceforge.nattable.command.ILayerCommand;

import org.eclipse.swt.graphics.Point;

/**
 * Fire this command to pop-up the rename column dialog.
 */
public class DisplayColumnRenameDialogCommand extends AbstractColumnCommand {

	private final NatTable natTable;

    /**
	 * @param columnPosition of the column to be renamed 
	 */
	public DisplayColumnRenameDialogCommand(NatTable natTable, int columnPosition) {
		super(natTable, columnPosition);
        this.natTable = natTable;
	}

	public Point toDisplayCoordingates(Point point) {
	    return natTable.toDisplay(point);
	}
	
	public ILayerCommand cloneCommand() {
		return new DisplayColumnRenameDialogCommand((NatTable) getLayer(), getColumnPosition());
	}

}
