package net.sourceforge.nattable.command;

import net.sourceforge.nattable.layer.ILayer;
import net.sourceforge.nattable.layer.event.StructuralRefreshEvent;

/**
 * Command that triggers a {@link StructuralRefreshEvent}.
 * To support refreshing of every layer in a NatTable the
 * {@link StructuralRefreshCommandHandler} should be registered 
 * against the DataLayer.
 * 
 * @author fipro
 *
 */
public class StructuralRefreshCommand implements ILayerCommand {

	public boolean convertToTargetLayer(ILayer targetLayer) {
		//no need for a check as the command simply triggers to fire a 
		//StructuralRefreshEvent
		return true;
	}

	public ILayerCommand cloneCommand() {
		//as the command doesn't have a state, the clone is simply a new instance
		return new StructuralRefreshCommand();
	}

}
