package net.sourceforge.nattable.config;

import net.sourceforge.nattable.layer.cell.LayerCell;

public interface IEditableRule {
	
	public boolean isEditable(LayerCell cell, IConfigRegistry configRegistry);
	public boolean isEditable(int columnIndex, int rowIndex);
	
	public static final IEditableRule ALWAYS_EDITABLE = new IEditableRule() {

		public boolean isEditable(LayerCell cell, IConfigRegistry configRegistry) {
			return true;
		}

		public boolean isEditable(int columnIndex, int rowIndex) {
			return true;
		}
		
	};
	
	public static final IEditableRule NEVER_EDITABLE = new IEditableRule() {

		public boolean isEditable(LayerCell cell, IConfigRegistry configRegistry) {
			return false;
		}

		public boolean isEditable(int columnIndex, int rowIndex) {
			return false;
		}
		
	};

}
