package net.sourceforge.nattable.data.convert;

import org.apache.commons.lang.NotImplementedException;

import net.sourceforge.nattable.config.IConfigRegistry;
import net.sourceforge.nattable.layer.cell.LayerCell;

public abstract class ContextualDisplayConverter implements IDisplayConverter {

	public Object canonicalToDisplayValue(Object canonicalValue) {
		throw new NotImplementedException(this.getClass().getName() 
				+ " is a ContextualDisplayConverter and has therefore to be called with context informations.");
	}

	public Object displayToCanonicalValue(Object displayValue) {
		throw new NotImplementedException(this.getClass().getName() 
				+ " is a ContextualDisplayConverter and has therefore to be called with context informations.");
	}

	public abstract Object canonicalToDisplayValue(LayerCell cell, IConfigRegistry configRegistry, Object canonicalValue);

	public abstract Object displayToCanonicalValue(LayerCell cell, IConfigRegistry configRegistry, Object displayValue);

}
