package net.sourceforge.nattable.edit.action;

import org.eclipse.swt.events.MouseEvent;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.edit.command.UpdateDataCommand;
import net.sourceforge.nattable.layer.IUniqueIndexLayer;
import net.sourceforge.nattable.layer.LayerUtil;
import net.sourceforge.nattable.painter.cell.ColumnHeaderCheckBoxPainter;
import net.sourceforge.nattable.ui.action.IMouseAction;

public class ToggleCheckBoxColumnAction implements IMouseAction {

	private final ColumnHeaderCheckBoxPainter columnHeaderCheckBoxPainter;
	private final IUniqueIndexLayer bodyDataLayer;

	public ToggleCheckBoxColumnAction(ColumnHeaderCheckBoxPainter columnHeaderCheckBoxPainter, IUniqueIndexLayer bodyDataLayer) {
		this.columnHeaderCheckBoxPainter = columnHeaderCheckBoxPainter;
		this.bodyDataLayer = bodyDataLayer;
	}
	
	public void run(NatTable natTable, MouseEvent event) {
		int sourceColumnPosition = natTable.getColumnPositionByX(event.x);
		int columnPosition = LayerUtil.convertColumnPosition(natTable, sourceColumnPosition, bodyDataLayer);
		
		int checkedCellsCount = columnHeaderCheckBoxPainter.getCheckedCellsCount(columnPosition, natTable.getConfigRegistry());
		boolean targetState = checkedCellsCount < bodyDataLayer.getRowCount();
		
		for (int rowPosition = 0; rowPosition < bodyDataLayer.getRowCount(); rowPosition++) {
			bodyDataLayer.doCommand(new UpdateDataCommand(bodyDataLayer, columnPosition, rowPosition, targetState));
		}
	}

}
