package net.sourceforge.nattable.export.command;

import net.sourceforge.nattable.command.AbstractLayerCommandHandler;
import net.sourceforge.nattable.config.IConfigRegistry;
import net.sourceforge.nattable.export.NatExporter;
import net.sourceforge.nattable.layer.ILayer;

import org.eclipse.swt.widgets.Shell;

public class ExportCommandHandler extends AbstractLayerCommandHandler<ExportCommand> {

	private final ILayer layer;

	public ExportCommandHandler(ILayer layer) {
		this.layer = layer;
	}

	@Override
	public boolean doCommand(final ExportCommand command) {
		Shell shell = command.getShell();
		IConfigRegistry configRegistry = command.getConfigRegistry();
		
		new NatExporter(shell).exportSingleLayer(layer, configRegistry);
		
		return true;
	}

	public Class<ExportCommand> getCommandClass() {
		return ExportCommand.class;
	}

}
