package net.sourceforge.nattable.extension.glazedlists.groupBy.action;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.extension.glazedlists.groupBy.GroupByHeaderLayer;
import net.sourceforge.nattable.extension.glazedlists.groupBy.command.GroupByColumnIndexCommand;
import net.sourceforge.nattable.layer.LabelStack;
import net.sourceforge.nattable.ui.action.IDragMode;

import org.eclipse.swt.events.MouseEvent;

public class GroupByDragMode implements IDragMode {

	private MouseEvent initialEvent;

	public void mouseDown(NatTable natTable, MouseEvent event) {
		initialEvent = event;
	}

	public void mouseMove(NatTable natTable, MouseEvent event) {
	}

	public void mouseUp(NatTable natTable, MouseEvent event) {
		LabelStack regionLabels = natTable.getRegionLabelsByXY(event.x, event.y);
		if (regionLabels.hasLabel(GroupByHeaderLayer.GROUP_BY_REGION)) {
			int columnPosition = natTable.getColumnPositionByX(initialEvent.x);
			int columnIndex = natTable.getColumnIndexByPosition(columnPosition);
			natTable.doCommand(new GroupByColumnIndexCommand(columnIndex));
		}
	}
	
}
