package net.sourceforge.nattable.ui;

import net.sourceforge.nattable.NatTable;
import net.sourceforge.nattable.layer.LabelStack;

import org.eclipse.swt.events.MouseEvent;

public class NatEventData {
	
	private MouseEvent originalEvent;
	private final NatTable natTable;
	private final LabelStack regionLabels;
	int columnPosition;
	int rowPosition;

	public static NatEventData createInstanceFromEvent(MouseEvent event) {
		NatTable natTable = (NatTable) event.widget;
		
		int columnPosition = natTable.getColumnPositionByX(event.x);
		int rowPosition = natTable.getRowPositionByY(event.y);
        
        return new NatEventData(
				natTable,
				natTable.getRegionLabelsByXY(event.x, event.y),
				columnPosition,
				rowPosition,
				event
		);
	}
	
	public NatEventData(NatTable natTable, LabelStack regionLabels, int columnPosition, int rowPosition, MouseEvent originalEvent) {
		this.natTable = natTable;
		this.regionLabels = regionLabels;
		this.columnPosition = columnPosition;
		this.rowPosition = rowPosition;
		this.originalEvent = originalEvent;
	}

	public NatTable getNatTable() {
		return natTable;
	}

	public LabelStack getRegionLabels() {
		return regionLabels;
	}

	public int getColumnPosition() {
		return columnPosition;
	}

	public int getRowPosition() {
		return rowPosition;
	}
	
	public MouseEvent getOriginalEvent() {
		return originalEvent;
	}

}